<template>
    <div>
        <form class="forms-sample">
            <div class="row">
                <div class="col-sm-12">
                    <div class="form-group">
                        <label for="exampleInputUsername1">Name</label>
                        <input type="text" class="form-control" id="name" autocomplete="off" v-model="data.first_name" v-validate="'required'" name="name" data-vv-as="Event">
                        <div>{{ veeErrors.first('name') }}</div>
                    </div>
                </div>
                <div class="col-sm-12 form-group">
                  <label>Category</label>
                  <b-form-select class="form-group" name="role" v-model="selectedRole" :options="roles" v-validate="'required'"></b-form-select>
                  <div class="text-danger">{{ veeErrors.first('role') }}</div>
              </div>
              <div class="col-sm-12" v-if="type == 'edit'">
                  <div class="form-group">
                      <label for="exampleInputUsername1">Confirmed</label>
                      <toggle-button v-model="data.confirmed" :value="data.confirmed" :sync="true" :labels="true" @change="changeStatus(data.confirmed)"/>
                  </div>
              </div>
          </div>


          <button type="submit" @click.prevent="back()" class="btn btn-secondary mr-2">Back</button>
          <button type="submit" @click.prevent="submit()" class="btn btn-success mr-2">Save</button>

      </form>
  </div>
</template>

<script>

    export default {
        props:['dataprop'],
        data() {
           return {
            url:'',
            type:'',
            data:{},
            selectedRole:null,
            roles:[],
        }
    },

    created(){
        this.initial()
        this.getRole()
    },

    methods:{  
        initial(){
         this.url  = this.dataprop.url 
         this.type = this.dataprop.type      
         if(!_.isEmpty(this.dataprop.data)){
            this.data = this.dataprop.data
            // console.log(this.data)
            this.selectedRole = this.data.roles[0].id
            this.data.confirmed = ( this.data.confirmed) ? true : false
        }
    },
    async getRole(){
        let url = `/admin/inovator/role`,
            getData = [{value: null, text: 'Pilih Role', disabled: true}];
        await axios.post(url, {}).then((res) => {
            $.each(res.data, function(key, val){
              getData.push( {
                value: val.id,
                text: val.name
            })
          })
            this.roles = getData
      })
    },
    getImage(img){
        return `/${img}`
    },
    submit(){
        this.$validator.validate().then(valid => {
            if (valid) {
             this.data.role = this.selectedRole
             this.axiosForm(this.data)
         }
     });
    },
    axiosForm(data){
        let self = this
        var formData = this.formData(data)
        axios.post(this.url,formData).then(function(response) {
            self.data = response.data
            let msg = self.titleCase(self.type) + ' Success!'
            self.$swal('Attention!', msg, 'success')
            self.clearAll()
            self.back()
        })
        .catch(function(error) {
            // console.error(error);
        });
    },
    titleCase(str) {
      str = str.toLowerCase().split(' ');
      for (var i = 0; i < str.length; i++) {
        str[i] = str[i].charAt(0).toUpperCase() + str[i].slice(1); 
    }
    return str.join(' ');
},
clearAll(){
    this.data = {}
    this.veeErrors.items = []
},
back(){
    this.toParent('list',this.data)
},
formData(obj){
    var formData = new FormData();
    for (var key in obj) {
        formData.append(key, obj[key]);
    }
    return formData;
},
toParent(action,data){
    let dataEmit = {
        action : action,
        data : data,
    }
    this.$emit('datacomponent', dataEmit)
},

changeStatus(status){
  let id = (this.data.id),
  active = (status) ? 1 : 0,
  link = `inovator/status/${id}/${active}`
  axios.get(link).then((response) => {})
},

}
}
</script>
<style>
    .square {
      width: 100px;
      height: 100px;
      background: white;
  }

  .colorin {
      background: #66D1D1;
      padding:5px;
      border-radius:3px;
  }
</style>
